searchData={"items":[{"type":"module","title":"Surrealix","doc":"Main entry module for Surrealix","ref":"Surrealix.html"},{"type":"function","title":"Surrealix.all_live_queries/1","doc":"Show all currently registered live queries (SQL)","ref":"Surrealix.html#all_live_queries/1"},{"type":"function","title":"Surrealix.authenticate/2","doc":"authenticate [ token ]\n  This method allows you to authenticate a user against SurrealDB with a token\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"authenticate\",\n      \"params\": [\n        \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#authenticate/2"},{"type":"function","title":"Surrealix.authenticate/3","doc":"","ref":"Surrealix.html#authenticate/3"},{"type":"function","title":"Surrealix.authenticate/4","doc":"","ref":"Surrealix.html#authenticate/4"},{"type":"function","title":"Surrealix.create/3","doc":"create [ thing, data ]\n  This method creates a record either with a random or specified ID\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"create\",\n      \"params\": [\n        \"person\",\n        {\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }","ref":"Surrealix.html#create/3"},{"type":"function","title":"Surrealix.create/4","doc":"","ref":"Surrealix.html#create/4"},{"type":"function","title":"Surrealix.create/5","doc":"","ref":"Surrealix.html#create/5"},{"type":"function","title":"Surrealix.delete/2","doc":"delete [ thing ]\n  This method deletes either all records in a table or a single record\n  NOTE: Notice how the deleted record is being returned here\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"delete\",\n      \"params\": [\n        \"person:8s0j0bbm3ngrd5c9bx53\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"active\": true,\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"last_updated\": \"2023-06-16T08:34:25Z\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.html#delete/2"},{"type":"function","title":"Surrealix.delete/3","doc":"","ref":"Surrealix.html#delete/3"},{"type":"function","title":"Surrealix.delete/4","doc":"","ref":"Surrealix.html#delete/4"},{"type":"function","title":"Surrealix.info/1","doc":"info\n  This method returns the record of an authenticated scope user.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"info\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"id\": \"user:john\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.html#info/1"},{"type":"function","title":"Surrealix.insert/3","doc":"insert [ thing, data ]\n  This method creates a record either with a random or specified ID\n  Single insert\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"insert\",\n      \"params\": [\n        \"person\",\n        {\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n  Bulk insert\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"insert\",\n      \"params\": [\n        \"person\",\n        [\n          {\n            \"name\": \"Mary Doe\"\n          },\n          {\n            \"name\": \"John Doe\"\n          }\n        ]\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        },\n        {\n          \"id\": \"person:xtbbojcm82a97vus9x0j\",\n          \"name\": \"John Doe\"\n        }\n      ]\n    }","ref":"Surrealix.html#insert/3"},{"type":"function","title":"Surrealix.insert/4","doc":"","ref":"Surrealix.html#insert/4"},{"type":"function","title":"Surrealix.insert/5","doc":"","ref":"Surrealix.html#insert/5"},{"type":"function","title":"Surrealix.invalidate/1","doc":"invalidate\n  This method will invalidate the user's session for the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"invalidate\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#invalidate/1"},{"type":"function","title":"Surrealix.kill/2","doc":"kill [ queryUuid ]\n  This methods kills an active live query\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"kill\",\n      \"params\": [\n        \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#kill/2"},{"type":"function","title":"Surrealix.kill/3","doc":"","ref":"Surrealix.html#kill/3"},{"type":"function","title":"Surrealix.kill/4","doc":"","ref":"Surrealix.html#kill/4"},{"type":"function","title":"Surrealix.let/3","doc":"let [ name, value ]\n  This method stores a variable on the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"let\",\n      \"params\": [\n        \"website\",\n        \"https://surrealdb.com/\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#let/3"},{"type":"function","title":"Surrealix.let/4","doc":"","ref":"Surrealix.html#let/4"},{"type":"function","title":"Surrealix.let/5","doc":"","ref":"Surrealix.html#let/5"},{"type":"function","title":"Surrealix.live/3","doc":"live [ table ]\n  This methods initiates a live query for a specified table name\n  NOTE: For more advanced live queries where filters are needed, use the Query method to initiate a custom live query.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"live\",\n      \"params\": [\n        \"person\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n    }\n  Live notification\n\n  Example request:\n    {}\n\n  Example response:\n    {\n      \"result\": {\n        \"action\": \"CREATE\",\n        \"id\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\",\n        \"result\": {\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John\"\n        }\n      }\n    }","ref":"Surrealix.html#live/3"},{"type":"function","title":"Surrealix.live/4","doc":"","ref":"Surrealix.html#live/4"},{"type":"function","title":"Surrealix.live/5","doc":"","ref":"Surrealix.html#live/5"},{"type":"function","title":"Surrealix.live_query/4","doc":"Convenience method, that combines sending an query (live_query) and registering a callback\n\nParams:\n  sql: string\n  vars: map with variables to interpolate into SQL\n  callback: fn (event, data, config)","ref":"Surrealix.html#live_query/4"},{"type":"function","title":"Surrealix.merge/3","doc":"merge [ thing, data ]\n  This method merges specified data into either all records in a table or a single record\n  NOTE: This function merges the current document / record data with the specified data. If no merge data is passed it will simply trigger an update.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"merge\",\n      \"params\": [\n        \"person\",\n        {\n          \"active\": true\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"active\": true,\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John Doe\"\n        },\n        {\n          \"active\": true,\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }","ref":"Surrealix.html#merge/3"},{"type":"function","title":"Surrealix.merge/4","doc":"","ref":"Surrealix.html#merge/4"},{"type":"function","title":"Surrealix.merge/5","doc":"","ref":"Surrealix.html#merge/5"},{"type":"function","title":"Surrealix.patch/4","doc":"patch [ thing, patches, diff ]\n  This method patches either all records in a table or a single record with specified patches\n  NOTE: This function patches the current document / record data with the specified JSON Patch data.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"patch\",\n      \"params\": [\n        \"person\",\n        [\n          {\n            \"op\": \"replace\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ]\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        [\n          {\n            \"op\": \"add\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ],\n        [\n          {\n            \"op\": \"add\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ]\n      ]\n    }","ref":"Surrealix.html#patch/4"},{"type":"function","title":"Surrealix.patch/5","doc":"","ref":"Surrealix.html#patch/5"},{"type":"function","title":"Surrealix.patch/6","doc":"","ref":"Surrealix.html#patch/6"},{"type":"function","title":"Surrealix.ping/1","doc":"ping\n  This method pings the SurrealDB instance\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"ping\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#ping/1"},{"type":"function","title":"Surrealix.query/3","doc":"query [ sql, vars ]\n  This method executes a custom query against SurrealDB\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"query\",\n      \"params\": [\n        \"CREATE person SET name = 'John'; SELECT * FROM type::table($tb);\",\n        {\n          \"tb\": \"person\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"status\": \"OK\",\n          \"time\": \"152.5µs\",\n          \"result\": [\n            {\n              \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n              \"name\": \"John\"\n            }\n          ]\n        },\n        {\n          \"status\": \"OK\",\n          \"time\": \"32.375µs\",\n          \"result\": [\n            {\n              \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n              \"name\": \"John\"\n            }\n          ]\n        }\n      ]\n    }","ref":"Surrealix.html#query/3"},{"type":"function","title":"Surrealix.query/4","doc":"","ref":"Surrealix.html#query/4"},{"type":"function","title":"Surrealix.query/5","doc":"","ref":"Surrealix.html#query/5"},{"type":"function","title":"Surrealix.select/2","doc":"select [ thing ]\n  This method selects either all records in a table or a single record\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"select\",\n      \"params\": [\n        \"person\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John\"\n        }\n      ]\n    }","ref":"Surrealix.html#select/2"},{"type":"function","title":"Surrealix.select/3","doc":"","ref":"Surrealix.html#select/3"},{"type":"function","title":"Surrealix.select/4","doc":"","ref":"Surrealix.html#select/4"},{"type":"function","title":"Surrealix.signin/2","doc":"signin [ NS, DB, SC, ... ]\n  This method allows you to signin a root, NS, DB or SC user against SurrealDB\n  As Root\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signin\",\n      \"params\": [\n        {\n          \"user\": \"tobie\",\n          \"pass\": \"3xtr3m3ly-s3cur3-p@ssw0rd\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }\n  Signin as scope\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signin\",\n      \"params\": [\n        {\n          \"NS\": \"surrealdb\",\n          \"DB\": \"docs\",\n          \"SC\": \"commenter\",\n          \"username\": \"johndoe\",\n          \"password\": \"SuperStrongPassword!\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n    }","ref":"Surrealix.html#signin/2"},{"type":"function","title":"Surrealix.signin/3","doc":"","ref":"Surrealix.html#signin/3"},{"type":"function","title":"Surrealix.signin/4","doc":"","ref":"Surrealix.html#signin/4"},{"type":"function","title":"Surrealix.signup/2","doc":"signup [ NS, DB, SC, ... ]\n  This method allows you to signup a user against a scope's SIGNUP method\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signup\",\n      \"params\": [\n        {\n          \"NS\": \"surrealdb\",\n          \"DB\": \"docs\",\n          \"SC\": \"commenter\",\n          \"username\": \"johndoe\",\n          \"password\": \"SuperStrongPassword!\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n    }","ref":"Surrealix.html#signup/2"},{"type":"function","title":"Surrealix.signup/3","doc":"","ref":"Surrealix.html#signup/3"},{"type":"function","title":"Surrealix.signup/4","doc":"","ref":"Surrealix.html#signup/4"},{"type":"function","title":"Surrealix.start/1","doc":"","ref":"Surrealix.html#start/1"},{"type":"function","title":"Surrealix.start_link/1","doc":"","ref":"Surrealix.html#start_link/1"},{"type":"function","title":"Surrealix.stop/1","doc":"","ref":"Surrealix.html#stop/1"},{"type":"function","title":"Surrealix.unset/2","doc":"unset [ name ]\n  This method removes a variable from the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"unset\",\n      \"params\": [\n        \"website\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#unset/2"},{"type":"function","title":"Surrealix.unset/3","doc":"","ref":"Surrealix.html#unset/3"},{"type":"function","title":"Surrealix.unset/4","doc":"","ref":"Surrealix.html#unset/4"},{"type":"function","title":"Surrealix.update/3","doc":"update [ thing, data ]\n  This method replaces either all records in a table or a single record with specified data\n  NOTE: This function replaces the current document / record data with the specified data. If no replacement data is passed it will simply trigger an update.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"update\",\n      \"params\": [\n        \"person:8s0j0bbm3ngrd5c9bx53\",\n        {\n          \"name\": \"John Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.html#update/3"},{"type":"function","title":"Surrealix.update/4","doc":"","ref":"Surrealix.html#update/4"},{"type":"function","title":"Surrealix.update/5","doc":"","ref":"Surrealix.html#update/5"},{"type":"function","title":"Surrealix.use/3","doc":"use [ ns, db ]\n  Specifies the namespace and database for the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"use\",\n      \"params\": [\n        \"surrealdb\",\n        \"docs\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#use/3"},{"type":"function","title":"Surrealix.use/4","doc":"","ref":"Surrealix.html#use/4"},{"type":"function","title":"Surrealix.use/5","doc":"","ref":"Surrealix.html#use/5"},{"type":"module","title":"Surrealix.Accessible","doc":"A vendored package, that makes reaching into deep structs little bit nicer.","ref":"Surrealix.Accessible.html"},{"type":"module","title":"Surrealix.Api","doc":"Thin layer over the Websockets API for SurrealDB that is 100% generated from a data-structure.","ref":"Surrealix.Api.html"},{"type":"function","title":"Surrealix.Api.all_live_queries/1","doc":"Show all currently registered live queries (SQL)","ref":"Surrealix.Api.html#all_live_queries/1"},{"type":"function","title":"Surrealix.Api.authenticate/2","doc":"authenticate [ token ]\n  This method allows you to authenticate a user against SurrealDB with a token\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"authenticate\",\n      \"params\": [\n        \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#authenticate/2"},{"type":"function","title":"Surrealix.Api.authenticate/4","doc":"","ref":"Surrealix.Api.html#authenticate/4"},{"type":"function","title":"Surrealix.Api.build_cast_payload/3","doc":"","ref":"Surrealix.Api.html#build_cast_payload/3"},{"type":"function","title":"Surrealix.Api.create/3","doc":"create [ thing, data ]\n  This method creates a record either with a random or specified ID\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"create\",\n      \"params\": [\n        \"person\",\n        {\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }","ref":"Surrealix.Api.html#create/3"},{"type":"function","title":"Surrealix.Api.create/5","doc":"","ref":"Surrealix.Api.html#create/5"},{"type":"function","title":"Surrealix.Api.delete/2","doc":"delete [ thing ]\n  This method deletes either all records in a table or a single record\n  NOTE: Notice how the deleted record is being returned here\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"delete\",\n      \"params\": [\n        \"person:8s0j0bbm3ngrd5c9bx53\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"active\": true,\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"last_updated\": \"2023-06-16T08:34:25Z\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.Api.html#delete/2"},{"type":"function","title":"Surrealix.Api.delete/4","doc":"","ref":"Surrealix.Api.html#delete/4"},{"type":"function","title":"Surrealix.Api.info/1","doc":"info\n  This method returns the record of an authenticated scope user.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"info\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"id\": \"user:john\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.Api.html#info/1"},{"type":"function","title":"Surrealix.Api.info/3","doc":"","ref":"Surrealix.Api.html#info/3"},{"type":"function","title":"Surrealix.Api.insert/3","doc":"insert [ thing, data ]\n  This method creates a record either with a random or specified ID\n  Single insert\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"insert\",\n      \"params\": [\n        \"person\",\n        {\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n  Bulk insert\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"insert\",\n      \"params\": [\n        \"person\",\n        [\n          {\n            \"name\": \"Mary Doe\"\n          },\n          {\n            \"name\": \"John Doe\"\n          }\n        ]\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        },\n        {\n          \"id\": \"person:xtbbojcm82a97vus9x0j\",\n          \"name\": \"John Doe\"\n        }\n      ]\n    }","ref":"Surrealix.Api.html#insert/3"},{"type":"function","title":"Surrealix.Api.insert/5","doc":"","ref":"Surrealix.Api.html#insert/5"},{"type":"function","title":"Surrealix.Api.invalidate/1","doc":"invalidate\n  This method will invalidate the user's session for the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"invalidate\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#invalidate/1"},{"type":"function","title":"Surrealix.Api.invalidate/3","doc":"","ref":"Surrealix.Api.html#invalidate/3"},{"type":"function","title":"Surrealix.Api.kill/2","doc":"kill [ queryUuid ]\n  This methods kills an active live query\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"kill\",\n      \"params\": [\n        \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#kill/2"},{"type":"function","title":"Surrealix.Api.kill/4","doc":"","ref":"Surrealix.Api.html#kill/4"},{"type":"function","title":"Surrealix.Api.let/3","doc":"let [ name, value ]\n  This method stores a variable on the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"let\",\n      \"params\": [\n        \"website\",\n        \"https://surrealdb.com/\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#let/3"},{"type":"function","title":"Surrealix.Api.let/5","doc":"","ref":"Surrealix.Api.html#let/5"},{"type":"function","title":"Surrealix.Api.live/3","doc":"live [ table ]\n  This methods initiates a live query for a specified table name\n  NOTE: For more advanced live queries where filters are needed, use the Query method to initiate a custom live query.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"live\",\n      \"params\": [\n        \"person\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n    }\n  Live notification\n\n  Example request:\n    {}\n\n  Example response:\n    {\n      \"result\": {\n        \"action\": \"CREATE\",\n        \"id\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\",\n        \"result\": {\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John\"\n        }\n      }\n    }","ref":"Surrealix.Api.html#live/3"},{"type":"function","title":"Surrealix.Api.live/5","doc":"","ref":"Surrealix.Api.html#live/5"},{"type":"function","title":"Surrealix.Api.live_query/4","doc":"Convenience method that combines sending a (live-)query and registering a callback.\n\nParams:\n    sql: string\n    vars: map with variables to interpolate into SQL\n    callback: fn (event, data, config)","ref":"Surrealix.Api.html#live_query/4"},{"type":"function","title":"Surrealix.Api.merge/3","doc":"merge [ thing, data ]\n  This method merges specified data into either all records in a table or a single record\n  NOTE: This function merges the current document / record data with the specified data. If no merge data is passed it will simply trigger an update.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"merge\",\n      \"params\": [\n        \"person\",\n        {\n          \"active\": true\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"active\": true,\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John Doe\"\n        },\n        {\n          \"active\": true,\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }","ref":"Surrealix.Api.html#merge/3"},{"type":"function","title":"Surrealix.Api.merge/5","doc":"","ref":"Surrealix.Api.html#merge/5"},{"type":"function","title":"Surrealix.Api.patch/4","doc":"patch [ thing, patches, diff ]\n  This method patches either all records in a table or a single record with specified patches\n  NOTE: This function patches the current document / record data with the specified JSON Patch data.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"patch\",\n      \"params\": [\n        \"person\",\n        [\n          {\n            \"op\": \"replace\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ]\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        [\n          {\n            \"op\": \"add\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ],\n        [\n          {\n            \"op\": \"add\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ]\n      ]\n    }","ref":"Surrealix.Api.html#patch/4"},{"type":"function","title":"Surrealix.Api.patch/6","doc":"","ref":"Surrealix.Api.html#patch/6"},{"type":"function","title":"Surrealix.Api.ping/1","doc":"ping\n  This method pings the SurrealDB instance\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"ping\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#ping/1"},{"type":"function","title":"Surrealix.Api.ping/3","doc":"","ref":"Surrealix.Api.html#ping/3"},{"type":"function","title":"Surrealix.Api.query/3","doc":"query [ sql, vars ]\n  This method executes a custom query against SurrealDB\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"query\",\n      \"params\": [\n        \"CREATE person SET name = 'John'; SELECT * FROM type::table($tb);\",\n        {\n          \"tb\": \"person\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"status\": \"OK\",\n          \"time\": \"152.5µs\",\n          \"result\": [\n            {\n              \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n              \"name\": \"John\"\n            }\n          ]\n        },\n        {\n          \"status\": \"OK\",\n          \"time\": \"32.375µs\",\n          \"result\": [\n            {\n              \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n              \"name\": \"John\"\n            }\n          ]\n        }\n      ]\n    }","ref":"Surrealix.Api.html#query/3"},{"type":"function","title":"Surrealix.Api.query/5","doc":"","ref":"Surrealix.Api.html#query/5"},{"type":"function","title":"Surrealix.Api.select/2","doc":"select [ thing ]\n  This method selects either all records in a table or a single record\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"select\",\n      \"params\": [\n        \"person\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John\"\n        }\n      ]\n    }","ref":"Surrealix.Api.html#select/2"},{"type":"function","title":"Surrealix.Api.select/4","doc":"","ref":"Surrealix.Api.html#select/4"},{"type":"function","title":"Surrealix.Api.signin/2","doc":"signin [ NS, DB, SC, ... ]\n  This method allows you to signin a root, NS, DB or SC user against SurrealDB\n  As Root\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signin\",\n      \"params\": [\n        {\n          \"user\": \"tobie\",\n          \"pass\": \"3xtr3m3ly-s3cur3-p@ssw0rd\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }\n  Signin as scope\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signin\",\n      \"params\": [\n        {\n          \"NS\": \"surrealdb\",\n          \"DB\": \"docs\",\n          \"SC\": \"commenter\",\n          \"username\": \"johndoe\",\n          \"password\": \"SuperStrongPassword!\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n    }","ref":"Surrealix.Api.html#signin/2"},{"type":"function","title":"Surrealix.Api.signin/4","doc":"","ref":"Surrealix.Api.html#signin/4"},{"type":"function","title":"Surrealix.Api.signup/2","doc":"signup [ NS, DB, SC, ... ]\n  This method allows you to signup a user against a scope's SIGNUP method\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signup\",\n      \"params\": [\n        {\n          \"NS\": \"surrealdb\",\n          \"DB\": \"docs\",\n          \"SC\": \"commenter\",\n          \"username\": \"johndoe\",\n          \"password\": \"SuperStrongPassword!\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n    }","ref":"Surrealix.Api.html#signup/2"},{"type":"function","title":"Surrealix.Api.signup/4","doc":"","ref":"Surrealix.Api.html#signup/4"},{"type":"function","title":"Surrealix.Api.unset/2","doc":"unset [ name ]\n  This method removes a variable from the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"unset\",\n      \"params\": [\n        \"website\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#unset/2"},{"type":"function","title":"Surrealix.Api.unset/4","doc":"","ref":"Surrealix.Api.html#unset/4"},{"type":"function","title":"Surrealix.Api.update/3","doc":"update [ thing, data ]\n  This method replaces either all records in a table or a single record with specified data\n  NOTE: This function replaces the current document / record data with the specified data. If no replacement data is passed it will simply trigger an update.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"update\",\n      \"params\": [\n        \"person:8s0j0bbm3ngrd5c9bx53\",\n        {\n          \"name\": \"John Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.Api.html#update/3"},{"type":"function","title":"Surrealix.Api.update/5","doc":"","ref":"Surrealix.Api.html#update/5"},{"type":"function","title":"Surrealix.Api.use/3","doc":"use [ ns, db ]\n  Specifies the namespace and database for the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"use\",\n      \"params\": [\n        \"surrealdb\",\n        \"docs\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#use/3"},{"type":"function","title":"Surrealix.Api.use/5","doc":"","ref":"Surrealix.Api.html#use/5"},{"type":"module","title":"Surrealix.Config","doc":"Explicit config module to keep configurable options in a single place","ref":"Surrealix.Config.html"},{"type":"function","title":"Surrealix.Config.base_conn_opts/0","doc":"","ref":"Surrealix.Config.html#base_conn_opts/0"},{"type":"function","title":"Surrealix.Config.task_opts_default/0","doc":"","ref":"Surrealix.Config.html#task_opts_default/0"},{"type":"type","title":"Surrealix.Config.base_connection_opts/0","doc":"","ref":"Surrealix.Config.html#t:base_connection_opts/0"},{"type":"type","title":"Surrealix.Config.socket_opts/0","doc":"","ref":"Surrealix.Config.html#t:socket_opts/0"},{"type":"module","title":"Surrealix.Dispatch","doc":"Handles callback registration (for only when using live queries).\nBased on ideas here: https://github.com/keathley/sync_dispatch\n  - which itself is based on :telemetry (https://hex.pm/packages/telemetry) implementation.","ref":"Surrealix.Dispatch.html"},{"type":"function","title":"Surrealix.Dispatch.attach/4","doc":"Attaches a function to an event. The provided id is used for idempotence.\nDifferent handlers should use unique handler ids.","ref":"Surrealix.Dispatch.html#attach/4"},{"type":"function","title":"Surrealix.Dispatch.execute/2","doc":"Executes an event and any handlers that are attached to the event name. `data`\ncan be any term().","ref":"Surrealix.Dispatch.html#execute/2"},{"type":"function","title":"Surrealix.Dispatch.remove_by_event/1","doc":"","ref":"Surrealix.Dispatch.html#remove_by_event/1"},{"type":"function","title":"Surrealix.Dispatch.remove_by_id/1","doc":"","ref":"Surrealix.Dispatch.html#remove_by_id/1"},{"type":"type","title":"Surrealix.Dispatch.handler_function/0","doc":"","ref":"Surrealix.Dispatch.html#t:handler_function/0"},{"type":"module","title":"Surrealix.HandlerTable","doc":"Wrapper around ETS to store callbacks for live queries. Modelled after :telemetry.","ref":"Surrealix.HandlerTable.html"},{"type":"function","title":"Surrealix.HandlerTable.all/0","doc":"","ref":"Surrealix.HandlerTable.html#all/0"},{"type":"function","title":"Surrealix.HandlerTable.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Surrealix.HandlerTable.html#child_spec/1"},{"type":"function","title":"Surrealix.HandlerTable.delete_all/0","doc":"","ref":"Surrealix.HandlerTable.html#delete_all/0"},{"type":"function","title":"Surrealix.HandlerTable.handlers_for_event/1","doc":"","ref":"Surrealix.HandlerTable.html#handlers_for_event/1"},{"type":"function","title":"Surrealix.HandlerTable.init/1","doc":"","ref":"Surrealix.HandlerTable.html#init/1"},{"type":"function","title":"Surrealix.HandlerTable.insert/4","doc":"","ref":"Surrealix.HandlerTable.html#insert/4"},{"type":"function","title":"Surrealix.HandlerTable.remove_by_event/1","doc":"","ref":"Surrealix.HandlerTable.html#remove_by_event/1"},{"type":"function","title":"Surrealix.HandlerTable.remove_by_id/1","doc":"","ref":"Surrealix.HandlerTable.html#remove_by_id/1"},{"type":"function","title":"Surrealix.HandlerTable.start_link/1","doc":"","ref":"Surrealix.HandlerTable.html#start_link/1"},{"type":"module","title":"Surrealix.Socket","doc":"Socket module to wrap the interactions with `WebSockex` process.","ref":"Surrealix.Socket.html"},{"type":"function","title":"Surrealix.Socket.exec_method/3","doc":"","ref":"Surrealix.Socket.html#exec_method/3"},{"type":"function","title":"Surrealix.Socket.start/1","doc":"","ref":"Surrealix.Socket.html#start/1"},{"type":"function","title":"Surrealix.Socket.start_link/1","doc":"","ref":"Surrealix.Socket.html#start_link/1"},{"type":"function","title":"Surrealix.Socket.stop/1","doc":"","ref":"Surrealix.Socket.html#stop/1"},{"type":"type","title":"Surrealix.Socket.base_connection_opts/0","doc":"","ref":"Surrealix.Socket.html#t:base_connection_opts/0"},{"type":"type","title":"Surrealix.Socket.on_start/0","doc":"","ref":"Surrealix.Socket.html#t:on_start/0"},{"type":"module","title":"Surrealix.SocketState","doc":"SocketState module makes testing the State transitions for Socket much simpler","ref":"Surrealix.SocketState.html"},{"type":"function","title":"Surrealix.SocketState.__struct__/0","doc":"- `pending`: Pending requests map:  id => task\n  - `lq_running`: live_queries map:  id => %{sql: sql}\n  - `lq_sql`: live_queries SET with queries to register after re-connection","ref":"Surrealix.SocketState.html#__struct__/0"},{"type":"function","title":"Surrealix.SocketState.add_lq/3","doc":"Register a SQL statement for a particular LiveQuery ID","ref":"Surrealix.SocketState.html#add_lq/3"},{"type":"function","title":"Surrealix.SocketState.add_task/3","doc":"Register a task for a particular request ID","ref":"Surrealix.SocketState.html#add_task/3"},{"type":"function","title":"Surrealix.SocketState.all_lq/1","doc":"Currently registered LiveQueries","ref":"Surrealix.SocketState.html#all_lq/1"},{"type":"function","title":"Surrealix.SocketState.delete/2","doc":"","ref":"Surrealix.SocketState.html#delete/2"},{"type":"function","title":"Surrealix.SocketState.delete_lq_by_id/2","doc":"Remove a LiveQuery by ID","ref":"Surrealix.SocketState.html#delete_lq_by_id/2"},{"type":"function","title":"Surrealix.SocketState.delete_lq_by_sql/2","doc":"Remove a LiveQuery by SQL","ref":"Surrealix.SocketState.html#delete_lq_by_sql/2"},{"type":"function","title":"Surrealix.SocketState.delete_task/2","doc":"Remove a task for a particular request ID","ref":"Surrealix.SocketState.html#delete_task/2"},{"type":"function","title":"Surrealix.SocketState.get/3","doc":"","ref":"Surrealix.SocketState.html#get/3"},{"type":"function","title":"Surrealix.SocketState.get_lq/2","doc":"Get map that describes a particular LiveQuery ID (SQL / ID / etc)","ref":"Surrealix.SocketState.html#get_lq/2"},{"type":"function","title":"Surrealix.SocketState.get_task/2","doc":"Get a task for a particular request ID","ref":"Surrealix.SocketState.html#get_task/2"},{"type":"function","title":"Surrealix.SocketState.new/0","doc":"","ref":"Surrealix.SocketState.html#new/0"},{"type":"function","title":"Surrealix.SocketState.put/3","doc":"","ref":"Surrealix.SocketState.html#put/3"},{"type":"module","title":"Surrealix.Telemetry","doc":"Provides conventions to publishing `:telemetry` events","ref":"Surrealix.Telemetry.html"},{"type":"module","title":"Surrealix.Telemetry.Logger","doc":"Telemetry Logger. Hooks telemetry events and logs them to stdout.","ref":"Surrealix.Telemetry.Logger.html"},{"type":"function","title":"Surrealix.Telemetry.Logger.check/0","doc":"","ref":"Surrealix.Telemetry.Logger.html#check/0"},{"type":"function","title":"Surrealix.Telemetry.Logger.handle_event/4","doc":"","ref":"Surrealix.Telemetry.Logger.html#handle_event/4"},{"type":"function","title":"Surrealix.Telemetry.Logger.setup/0","doc":"","ref":"Surrealix.Telemetry.Logger.html#setup/0"},{"type":"module","title":"Surrealix.Util","doc":"Some generic utility functions","ref":"Surrealix.Util.html"},{"type":"function","title":"Surrealix.Util.is_live_query_stmt/1","doc":"A basic check to make sure the SQL statement is indeed a live query.\nProper check would require parsing the SQL statement and is outside of scope for this library.","ref":"Surrealix.Util.html#is_live_query_stmt/1"},{"type":"function","title":"Surrealix.Util.uuid/1","doc":"A small random string generator","ref":"Surrealix.Util.html#uuid/1"}],"content_type":"text/markdown"}